<!--
 * @Description: 
 * @Author: gcz
 * @Date: 2024-05-16 14:48:39
 * @LastEditors: gcz
 * @LastEditTime: 2024-05-21 14:59:18
 * @FilePath: \great_webui\src\views\statisticalReport\teamdetail.vue
 * @Copyright: Copyright (c) 2016~2024 by gcz, All Rights Reserved. 
-->
<template>
    <div class="app-container">
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="40px">
        <el-form-item label="日期">
          <el-date-picker
          style="width: 230px;"
            v-model="selectTime"
            type="daterange"
            value-format="yyyy-MM-dd"
            placeholder="日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="团队类型" label-width="120px">
          <el-select
            v-model="queryParams.teamType"
            placeholder="团队类型"
            @change="getList"
            clearable
            style="width: 140px"
          >
            <el-option
              v-for="dict in dict.type.team_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
      <el-row :gutter="10" class="mb8"  style="margin-left: 0; margin-top: 10px">
        <el-button
          type="primary"
          size="mini"
          icon="el-icon-download"
          :disabled="dataList.length === 0"
          v-hasPermi="['session:session:downloadExcel']"
          @click="handleExport"
          v-loading.fullscreen.lock="handleExportLoading"
          element-loading-text="正在拼命生成数据中..."
          element-loading-spinner="el-icon-loading"
          element-loading-background="rgba(0, 0, 0, 0.5)"
        >导出excel</el-button>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
  
      <el-table ref="tables" v-loading="loading" :data="dataList" border>
        <el-table-column label="序号" align="center" type="index" width="60"></el-table-column>
        <!-- <el-table-column label="剧目名称" align="center" prop="performName" />
        <el-table-column label="票务名称" align="center" prop="goodsName" /> -->
        <el-table-column label="团队类型" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.teamType }}</span>
          </template>
        </el-table-column>
        <el-table-column label="团队名称" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.teamName }}</span>
          </template>
        </el-table-column>
        <el-table-column label="票种(元)" align="center">
          
        </el-table-column>
        <el-table-column label="结算价（元）" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.settlementAmount }}</span>
          </template>
        </el-table-column>
        <el-table-column label="人次" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.personNext }}</span>
          </template>
        </el-table-column>
        <el-table-column label="收入" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.salePriceAmount }}</span>
          </template>
        </el-table-column>
        <el-table-column label="收入占比" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.incomeRatio?scope.row.incomeRatio+'%' : '-' }}</span>
          </template>
        </el-table-column>
        <el-table-column label="销售员" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.salerPerson }}</span>
          </template>
        </el-table-column>
        <el-table-column label="备注" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.remark }}</span>
          </template>
        </el-table-column>
      </el-table>
      <ul class="total-remark" v-if="responseData.saleTotalRemarkOnColor">
        <li><span class="til">合计:</span><div class="html-wap" v-html="responseData.saleTotalRemarkOnColor||'-'"></div> </li>
      </ul>
  
      <!-- <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      /> -->
  
    </div>
  </template>
  
  <script>
  
  import { marketTeamSaleCount, downMarketTeamSaleCount } from '@/api/statisticalReport/statistics'
  import { exportExcel } from '@/utils/exportexcel'
  import { seatPricePageList } from '@/api/distribution/ticketMr'
  import moment from "moment"
  export default {
    name: "",
    dicts: ['team_type'],
    data() {
      return {
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        // 非单个禁用
        single: true,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 用户表格数据
        dataList: [],
        // 弹出层标题
        title: "",
  
        // 是否显示弹出层
        open: false,
        // 日期范围
        dateRange: [],
        // 查询参数
        queryParams: {
          // pageNum: 1,
          // pageSize: 10,
        },
        visibleStatus: false,
        newObj: {},
        visibleType: '',
        handleExportLoading: false,
        tableData: {},
        ticketList: [],
        seatList: [],
        selectTime:'',
      };
    },
    created() {
    //   this.$set(this.queryParams,'performStartDate',moment().format("yyyy-MM-DD"))
      this.$set(this,'selectTime',[moment().format("yyyy-MM-DD"),moment().format("yyyy-MM-DD")]);
      this.getList();
      // this.ticketListApi();
    },
    methods: {
      /** 查询列表 */
      getList() {
        this.loading = true;
        if(this.selectTime){
          this.queryParams.beginDate = this.selectTime[0];
          this.queryParams.endDate = this.selectTime[1];
        }
        marketTeamSaleCount(this.addDateRange(this.queryParams, this.dateRange))
        .then(response => {
            this.responseData = response.data;
            this.dataList = response.data.dataList||[];
            this.total = response.data.total;
            this.loading = false;
          }
        ).catch(()=>{
          this.loading = false;
        });
      },
      /** 票务列表查询 */
      ticketListApi() {
        this.ticketList = []
        seatPricePageList(this.addDateRange({pageNum: 1, pageSize: 100}))
          .then(response => {
            let ticketItemList = []
            response.data.rows.forEach(item => {
              if(ticketItemList.indexOf(item.goodsId) == -1){
                this.ticketList.push(item);
                ticketItemList.push(item.goodsId);
              }
            })
          });
      },
      /** 座位类型列表 */
      getSeatTypeList(obj) {
        seatPricePageList(this.addDateRange({pageNum: 1, pageSize: 100, goodsId: obj.goodsId}))
          .then(response => {
            let ticketList = []
            response.data.rows.forEach(item => {
              if(ticketList.indexOf(item.seatTypeId) == -1){
                this.seatList.push(item);
                ticketList.push(item.seatTypeId);
              }
            })
          });
      },
      // 取消按钮
      cancel() {
        this.open = false;
      },
      // 票务改变事件
      goodsChangeEven() {
        this.seatList = [];
        this.$set(this.queryParams, 'seatTypeId', '');
        let selectMap = {goodsId: this.queryParams.goodsId}
        this.getSeatTypeList(selectMap);
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.dateRange = [];
        this.seatList = [];
        this.$set(this.queryParams, 'time', '');
        this.$set(this.queryParams, 'performStartDate', '');
        this.$set(this.queryParams, 'performEndDate', '');
        this.$set(this.queryParams, 'goodsId', '');
        this.$set(this.queryParams, 'seatTypeId', '');
        this.$set(this.queryParams, 'teamType', '');
        // this.queryParams.pageNum = 1;
        this.$set(this,'selectTime',[moment().format("yyyy-MM-DD"),moment().format("yyyy-MM-DD")]);
        this.handleQuery();
      },
      /**
       * 导出报表
       * @date 2022-10-24
       * @returns {any}
       */
      handleExport() {
        this.$confirm('您确定要导出当前查询的数据吗？', '提示', {
          confirmButtonText: '确定 ',
          cancelButtonText: '取消 ',
          type: 'warning'
        })
          .then(() => {
            this.handleExportLoading = true;
            // const { pageNum, pageSize} = this.params;
            let postMap = {}
            for (let key in this.queryParams) {
              if(key != 'pageNum' && key != 'pageSize'){
                postMap[key] = this.queryParams[key]
              }
            }
            downMarketTeamSaleCount(postMap)
              .then((res) => {
                exportExcel(res, '团队明细', '.xlsx');
                this.handleExportLoading = false;
              })
              .catch(() => {
                this.handleExportLoading = false;
              });
          })
          .catch(() => {
            this.$message.info('您已取消导出！');
          });
      },
    }
  };
  </script>
  <style lang="scss" scoped>
  .total-remark{
    margin-top: 24px;
    margin-bottom: 24px;
    padding-left: 0;
    li{
      list-style: none;
      display: flex;
      ::v-deep .html-wap{
        span{
          color: blue;
          margin: 0 5px;
          display: inline-block;
        }
      }
    }
    .til{
      font-weight: bold;
      color: #333;
    }
  }
  </style>